OGRE: Ogre::HashedVector< T > Class Template Reference - OGRE Documentation

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes

# Ogre::HashedVector< T > Class Template Reference
[General]

A hashed vector. More...

`#include <OgreCommon.h>`

List of all members.

## Public Types
typedef std::vector< T, STLAllocator< T, GeneralAllocPolicy > > | VectorImpl
typedef VectorImpl::value_type | value_type
typedef VectorImpl::pointer | pointer
typedef VectorImpl::reference | reference
typedef VectorImpl::const_reference | const_reference
typedef VectorImpl::size_type | size_type
typedef VectorImpl::difference_type | difference_type
typedef VectorImpl::iterator | iterator
typedef VectorImpl::const_iterator | const_iterator
typedef VectorImpl::reverse_iterator | reverse_iterator
typedef VectorImpl::const_reverse_iterator | const_reverse_iterator
## Public Member Functions
void | dirtyHash ()
bool | isHashDirty () const
iterator | begin ()
iterator | end ()
const_iterator | begin () const
const_iterator | end () const
reverse_iterator | rbegin ()
reverse_iterator | rend ()
const_reverse_iterator | rbegin () const
const_reverse_iterator | rend () const
size_type | size () const
size_type | max_size () const
size_type | capacity () const
bool | empty () const
reference | operator[] (size_type n)
const_reference | operator[] (size_type n) const
reference | at (size_type n)
const_reference | at (size_type n) const
| HashedVector ()
| HashedVector (size_type n)
| HashedVector (size_type n, const T &t)
| HashedVector (const HashedVector< T > &rhs)
template<class InputIterator >
| HashedVector (InputIterator a, InputIterator b)
| ~HashedVector ()
HashedVector< T > & | operator= (const HashedVector< T > &rhs)
void | reserve (size_t t)
reference | front ()
const_reference | front () const
reference | back ()
const_reference | back () const
void | push_back (const T &t)
void | pop_back ()
void | swap (HashedVector< T > &rhs)
iterator | insert (iterator pos, const T &t)
template<class InputIterator >
void | insert (iterator pos, InputIterator f, InputIterator l)
void | insert (iterator pos, size_type n, const T &x)
iterator | erase (iterator pos)
iterator | erase (iterator first, iterator last)
void | clear ()
void | resize (size_type n, const T &t=T())
bool | operator== (const HashedVector< T > &b)
bool | operator< (const HashedVector< T > &b)
uint32 | getHash () const
| Get the hash value.
## Protected Member Functions
void | addToHash (const T &newPtr) const
void | recalcHash () const
## Protected Attributes
VectorImpl | mList
uint32 | mListHash
bool | mListHashDirty

## Detailed Description

### template<typename T>
class Ogre::HashedVector< T >

A hashed vector.

Definition at line 306 of file OgreCommon.h.

## Member Typedef Documentation

template<typename T>

typedef VectorImpl::const_iterator Ogre::HashedVector< T >::const_iterator

Definition at line 336 of file OgreCommon.h.

template<typename T>

typedef VectorImpl::const_reference Ogre::HashedVector< T >::const_reference

Definition at line 332 of file OgreCommon.h.

template<typename T>

typedef VectorImpl::const_reverse_iterator Ogre::HashedVector< T >::const_reverse_iterator

Definition at line 338 of file OgreCommon.h.

template<typename T>

typedef VectorImpl::difference_type Ogre::HashedVector< T >::difference_type

Definition at line 334 of file OgreCommon.h.

template<typename T>

typedef VectorImpl::iterator Ogre::HashedVector< T >::iterator

Definition at line 335 of file OgreCommon.h.

template<typename T>

typedef VectorImpl::pointer Ogre::HashedVector< T >::pointer

Definition at line 330 of file OgreCommon.h.

template<typename T>

typedef VectorImpl::reference Ogre::HashedVector< T >::reference

Definition at line 331 of file OgreCommon.h.

template<typename T>

typedef VectorImpl::reverse_iterator Ogre::HashedVector< T >::reverse_iterator

Definition at line 337 of file OgreCommon.h.

template<typename T>

typedef VectorImpl::size_type Ogre::HashedVector< T >::size_type

Definition at line 333 of file OgreCommon.h.

template<typename T>

typedef VectorImpl::value_type Ogre::HashedVector< T >::value_type

Definition at line 329 of file OgreCommon.h.

template<typename T>

typedef std::vector<T, STLAllocator<T, GeneralAllocPolicy> > Ogre::HashedVector< T >::VectorImpl

Definition at line 309 of file OgreCommon.h.

## Constructor & Destructor Documentation

template<typename T>

Ogre::HashedVector< T >::HashedVector | ( |  | ) |

Definition at line 385 of file OgreCommon.h.

template<typename T>

Ogre::HashedVector< T >::HashedVector | ( | size_type | n | ) |

Definition at line 386 of file OgreCommon.h.

template<typename T>

Ogre::HashedVector< T >::HashedVector | ( | size_type | n,
|  | const T & | t |
| ) |  |  |

Definition at line 387 of file OgreCommon.h.

template<typename T>

Ogre::HashedVector< T >::HashedVector | ( | const HashedVector< T > & | rhs | ) |

Definition at line 388 of file OgreCommon.h.

template<typename T>
template<class InputIterator >

Ogre::HashedVector< T >::HashedVector | ( | InputIterator | a,
|  | InputIterator | b |
| ) |  |  |

Definition at line 392 of file OgreCommon.h.

template<typename T>

Ogre::HashedVector< T >::~HashedVector | ( |  | ) |

Definition at line 398 of file OgreCommon.h.

## Member Function Documentation

template<typename T>

void Ogre::HashedVector< T >::addToHash | ( | const T & | newPtr | ) | const`[protected]`

Definition at line 315 of file OgreCommon.h.

Referenced by Ogre::HashedVector< Light * >::insert(), Ogre::HashedVector< Light * >::push_back(), and Ogre::HashedVector< Light * >::recalcHash().

template<typename T>

reference Ogre::HashedVector< T >::at | ( | size_type | n | ) |

Definition at line 378 of file OgreCommon.h.

template<typename T>

const_reference Ogre::HashedVector< T >::at | ( | size_type | n | ) | const

Definition at line 384 of file OgreCommon.h.

template<typename T>

reference Ogre::HashedVector< T >::back | ( |  | ) |

Definition at line 415 of file OgreCommon.h.

template<typename T>

const_reference Ogre::HashedVector< T >::back | ( |  | ) | const

Definition at line 421 of file OgreCommon.h.

template<typename T>

iterator Ogre::HashedVector< T >::begin | ( |  | ) |

Definition at line 349 of file OgreCommon.h.

template<typename T>

const_iterator Ogre::HashedVector< T >::begin | ( |  | ) | const

Definition at line 356 of file OgreCommon.h.

template<typename T>

size_type Ogre::HashedVector< T >::capacity | ( |  | ) | const

Definition at line 369 of file OgreCommon.h.

template<typename T>

void Ogre::HashedVector< T >::clear | ( |  | ) |

Definition at line 476 of file OgreCommon.h.

template<typename T>

void Ogre::HashedVector< T >::dirtyHash | ( |  | ) |

Definition at line 340 of file OgreCommon.h.

Referenced by Ogre::HashedVector< Light * >::at(), Ogre::HashedVector< Light * >::back(), Ogre::HashedVector< Light * >::begin(), Ogre::HashedVector< Light * >::erase(), Ogre::HashedVector< Light * >::front(), Ogre::HashedVector< Light * >::HashedVector(), Ogre::HashedVector< Light * >::insert(), Ogre::HashedVector< Light * >::operator[](), Ogre::HashedVector< Light * >::pop_back(), Ogre::HashedVector< Light * >::rbegin(), Ogre::HashedVector< Light * >::resize(), and Ogre::HashedVector< Light * >::swap().

template<typename T>

bool Ogre::HashedVector< T >::empty | ( |  | ) | const

Definition at line 370 of file OgreCommon.h.

template<typename T>

const_iterator Ogre::HashedVector< T >::end | ( |  | ) | const

Definition at line 357 of file OgreCommon.h.

template<typename T>

iterator Ogre::HashedVector< T >::end | ( |  | ) |

Definition at line 355 of file OgreCommon.h.

Referenced by Ogre::HashedVector< Light * >::insert().

template<typename T>

iterator Ogre::HashedVector< T >::erase | ( | iterator | pos | ) |

Definition at line 464 of file OgreCommon.h.

template<typename T>

iterator Ogre::HashedVector< T >::erase | ( | iterator | first,
|  | iterator | last |
| ) |  |  |

Definition at line 470 of file OgreCommon.h.

template<typename T>

reference Ogre::HashedVector< T >::front | ( |  | ) |

Definition at line 408 of file OgreCommon.h.

template<typename T>

const_reference Ogre::HashedVector< T >::front | ( |  | ) | const

Definition at line 414 of file OgreCommon.h.

template<typename T>

uint32 Ogre::HashedVector< T >::getHash | ( |  | ) | const

Get the hash value.

Definition at line 502 of file OgreCommon.h.

template<typename T>
template<class InputIterator >

void Ogre::HashedVector< T >::insert | ( | iterator | pos,
|  | InputIterator | f,
|  | InputIterator | l |
| ) |  |  |

Definition at line 451 of file OgreCommon.h.

template<typename T>

void Ogre::HashedVector< T >::insert | ( | iterator | pos,
|  | size_type | n,
|  | const T & | x |
| ) |  |  |

Definition at line 458 of file OgreCommon.h.

template<typename T>

iterator Ogre::HashedVector< T >::insert | ( | iterator | pos,
|  | const T & | t |
| ) |  |  |

Definition at line 439 of file OgreCommon.h.

template<typename T>

bool Ogre::HashedVector< T >::isHashDirty | ( |  | ) | const

Definition at line 344 of file OgreCommon.h.

Referenced by Ogre::HashedVector< Light * >::getHash(), and Ogre::HashedVector< Light * >::push_back().

template<typename T>

size_type Ogre::HashedVector< T >::max_size | ( |  | ) | const

Definition at line 368 of file OgreCommon.h.

template<typename T>

bool Ogre::HashedVector< T >::operator< | ( | const HashedVector< T > & | b | ) |

Definition at line 497 of file OgreCommon.h.

template<typename T>

HashedVector<T>& Ogre::HashedVector< T >::operator= | ( | const HashedVector< T > & | rhs | ) |

Definition at line 399 of file OgreCommon.h.

template<typename T>

bool Ogre::HashedVector< T >::operator== | ( | const HashedVector< T > & | b | ) |

Definition at line 494 of file OgreCommon.h.

template<typename T>

reference Ogre::HashedVector< T >::operator[] | ( | size_type | n | ) |

Definition at line 371 of file OgreCommon.h.

template<typename T>

const_reference Ogre::HashedVector< T >::operator[] | ( | size_type | n | ) | const

Definition at line 377 of file OgreCommon.h.

template<typename T>

void Ogre::HashedVector< T >::pop_back | ( |  | ) |

Definition at line 429 of file OgreCommon.h.

template<typename T>

void Ogre::HashedVector< T >::push_back | ( | const T & | t | ) |

Definition at line 422 of file OgreCommon.h.

template<typename T>

reverse_iterator Ogre::HashedVector< T >::rbegin | ( |  | ) |

Definition at line 358 of file OgreCommon.h.

template<typename T>

const_reverse_iterator Ogre::HashedVector< T >::rbegin | ( |  | ) | const

Definition at line 365 of file OgreCommon.h.

template<typename T>

void Ogre::HashedVector< T >::recalcHash | ( |  | ) | const`[protected]`

Definition at line 319 of file OgreCommon.h.

Referenced by Ogre::HashedVector< Light * >::getHash().

template<typename T>

reverse_iterator Ogre::HashedVector< T >::rend | ( |  | ) |

Definition at line 364 of file OgreCommon.h.

template<typename T>

const_reverse_iterator Ogre::HashedVector< T >::rend | ( |  | ) | const

Definition at line 366 of file OgreCommon.h.

template<typename T>

void Ogre::HashedVector< T >::reserve | ( | size_t | t | ) |

Definition at line 407 of file OgreCommon.h.

template<typename T>

void Ogre::HashedVector< T >::resize | ( | size_type | n,
|  | const T & | t = `T()` |
| ) |  |  |

Definition at line 483 of file OgreCommon.h.

template<typename T>

size_type Ogre::HashedVector< T >::size | ( |  | ) | const

Definition at line 367 of file OgreCommon.h.

Referenced by Ogre::HashedVector< Light * >::resize().

template<typename T>

void Ogre::HashedVector< T >::swap | ( | HashedVector< T > & | rhs | ) |

Definition at line 434 of file OgreCommon.h.

## Member Data Documentation

template<typename T>

VectorImpl Ogre::HashedVector< T >::mList`[protected]`

Definition at line 311 of file OgreCommon.h.

Referenced by Ogre::HashedVector< Light * >::at(), Ogre::HashedVector< Light * >::back(), Ogre::HashedVector< Light * >::begin(), Ogre::HashedVector< Light * >::capacity(), Ogre::HashedVector< Light * >::clear(), Ogre::HashedVector< Light * >::empty(), Ogre::HashedVector< Light * >::end(), Ogre::HashedVector< Light * >::erase(), Ogre::HashedVector< Light * >::front(), Ogre::HashedVector< Light * >::insert(), Ogre::HashedVector< Light * >::max_size(), Ogre::HashedVector< Light * >::operator=(), Ogre::HashedVector< Light * >::operator[](), Ogre::HashedVector< Light * >::pop_back(), Ogre::HashedVector< Light * >::push_back(), Ogre::HashedVector< Light * >::rbegin(), Ogre::HashedVector< Light * >::recalcHash(), Ogre::HashedVector< Light * >::rend(), Ogre::HashedVector< Light * >::reserve(), Ogre::HashedVector< Light * >::resize(), Ogre::HashedVector< Light * >::size(), and Ogre::HashedVector< Light * >::swap().

template<typename T>

uint32 Ogre::HashedVector< T >::mListHash`[mutable, protected]`

Definition at line 312 of file OgreCommon.h.

Referenced by Ogre::HashedVector< Light * >::addToHash(), Ogre::HashedVector< Light * >::clear(), Ogre::HashedVector< Light * >::getHash(), Ogre::HashedVector< Light * >::operator<(), Ogre::HashedVector< Light * >::operator=(), Ogre::HashedVector< Light * >::operator==(), and Ogre::HashedVector< Light * >::recalcHash().

template<typename T>

bool Ogre::HashedVector< T >::mListHashDirty`[mutable, protected]`

Definition at line 313 of file OgreCommon.h.

Referenced by Ogre::HashedVector< Light * >::clear(), Ogre::HashedVector< Light * >::dirtyHash(), Ogre::HashedVector< Light * >::isHashDirty(), Ogre::HashedVector< Light * >::operator=(), and Ogre::HashedVector< Light * >::recalcHash().

The documentation for this class was generated from the following file:

- OgreCommon.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:54